//
//  AppDelegate.m
//  Pcm2mp3 - Cocoa GUI for pcm2mp3.sh batch converter script
//          - pcm2mp3.sh is based on lame
//  Created by Stanko Juzbasic on 10/5/19.
//  Copyright © 2019 Stanko Juzbasic. All rights reserved.
//

#import "AppDelegate.h"

long fmtIdx = 0;
long bitrateIdx = 0;
// read from user defaults and GUI
NSString *prefpath, *rate, *fmt;

@interface AppDelegate ()

@property (weak) IBOutlet NSWindow *window;
@property (weak) IBOutlet NSTextField *dirpath;
@property (weak) IBOutlet NSTextFieldCell *dirpathcell;
@property (weak) IBOutlet NSButton *convbutton;
@property (weak) IBOutlet NSPopUpButton *fmtbutton;
@property (weak) IBOutlet NSPopUpButton *bitratebutton;
@property (weak) IBOutlet NSTextField *pLabel;
@property (weak) IBOutlet NSTextField *sfLabel;
@property (weak) IBOutlet NSTextField *brLabel;
@property(copy) NSString *currentDirectoryPath;
@end

@implementation AppDelegate
//__________________________________________________________________________________
- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
    // read defaults: where is pcm2mp3.sh
    if ((prefpath = [self getUserDefault: @"pc2mp3shPath"]) == (NSString*)nil);
    // add buttons to pup-up
    [_bitratebutton addItemWithTitle: @"160"];
    [_bitratebutton addItemWithTitle: @"128"];
    [self.window setOpaque: NO];
    NSColor *semiTransparentDark =
    [NSColor colorWithDeviceRed:0.29 green:0.28 blue:0.33 alpha:0.89];
    [self.window setBackgroundColor:semiTransparentDark];
    NSColor *tColor =
    [NSColor colorWithDeviceRed:0.79 green:0.78 blue:0.73 alpha:0.95];
    [self.pLabel setFont:[NSFont fontWithName:@"Arial" size:12]];
    [self.pLabel setTextColor:tColor];
    [self.sfLabel setTextColor:tColor];
    [self.brLabel setTextColor:tColor];    
}
//__________________________________________________________________________________
- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)sender
{
    return YES;
}
//__________________________________________________________________________________
- (void)applicationWillTerminate:(NSNotification *)aNotification {
    // Code to tear down your application
    NSLog(@"Pcm2Mp3.app terminated");
}

//__________________________________________________________________________________
- (IBAction)fmtbuttonPressed:(id)sender {
    // 0 = aif; 1 = aiff; 2 = wav;
    fmtIdx = [sender indexOfSelectedItem];
    NSLog(@"%ld", fmtIdx);
}
//__________________________________________________________________________________
- (IBAction)bitratebuttonPressed:(id)sender {
    // 0 = 320; 1 = 256; 2 = 192; 3 = 160; 4 = 128;
    bitrateIdx = [sender indexOfSelectedItem];
    NSLog(@"%ld", bitrateIdx);
}
//__________________________________________________________________________________
- (IBAction)convbuttonPressed:(id)sender {
    
    switch (bitrateIdx){
            case 4:
                    rate = @" 128"; break;
            case 3:
                    rate = @" 160"; break;
            case 2:
                    rate = @" 192"; break;
            case 1:
                    rate = @" 256"; break;
        default:
                    rate = @" 320"; break;
            
    }
    
    switch (fmtIdx){
            case 2:
                    fmt = @"  wav";  break;
            case 1:
                    fmt = @"  aiff"; break;
        default:
                    fmt = @"  aif";  break;
            
    }
   
    NSString    *text        = [_dirpath stringValue]; //extraneous, to be used in future versions
    NSLog(@"%@", text);  

    [[NSFileManager defaultManager] changeCurrentDirectoryPath:[_dirpath stringValue]];
    
    NSString *workingPath1 = [[NSFileManager defaultManager]currentDirectoryPath];
    NSLog(@"%@",workingPath1);    
    
    NSTask *task = [[NSTask alloc] init];
       [task setLaunchPath:@"/bin/bash"];

    NSString *scriptpath = [NSString stringWithFormat:@"%@ ", prefpath];
    
    NSArray *args = [NSArray arrayWithObjects:@"-c",[NSString stringWithFormat: @"%@%@%@",scriptpath, rate, fmt],nil];
    NSLog(@"args: \n%@",args);

    [task setArguments: args];
    
//    [task setArguments:@[ @"-c", @"/Users/stanko/Applications/bin/pcm2mp3.sh 320 aif" ]];
    [task setStandardOutput:[NSPipe pipe]];
    [task setStandardInput:[NSPipe pipe]];
    
    [task launch];
    [task waitUntilExit];    
}
//__________________________________________________________________________________
- (NSString*) getUserDefault: (NSString *) path
{
    //	NSLog(@"%@", path;
    NSString *val = [[NSUserDefaults standardUserDefaults] objectForKey: path];

    if (val != nil)
        return val;
    else
        return (NSString*) nil;
}
//__________________________________________________________________________________
-(void)mDoSomething: (char*)cstr
{
    NSLog(@"%s",cstr);
    NSNotification *blah = (NSNotification*)@"Pcm2mp3 will quit";
    [self applicationWillTerminate:blah];
}
//__________________________________________________________________________________
-(void) mPostError:(char *)cstr
{
    char cMessage[64] = "Please put org.sj.pcm2mp3.plist into ~/Preferences";
    NSString *message = [NSString stringWithCString:cMessage encoding:NSASCIIStringEncoding];
    NSString *infoText = [NSString stringWithCString:cstr encoding:NSASCIIStringEncoding];
    NSAlert* mAlert = [[NSAlert alloc] init];
    [mAlert addButtonWithTitle:@"OK"];
    [mAlert setMessageText:message];
    [mAlert setInformativeText:infoText];
    [mAlert setAlertStyle: NSCriticalAlertStyle];

    [mAlert beginSheetModalForWindow:self.window
                    completionHandler:^(NSModalResponse returnCode) {
                           [self mDoSomething: cstr];
                       }];    
}
@end
